import java.awt.Color;
import java.awt.Component;

import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;

/**
 * Table cell rendered to highlight the words 'Online' or 'Offline' in green and red.
 *
 */
public class RenderRedGreen extends DefaultTableCellRenderer
{
   private static final Color darkGreen = new Color(0, 128, 0);

   /**
    * The constructor
    */
   public RenderRedGreen()
   {
      setHorizontalAlignment(SwingConstants.CENTER);
   }

   /**
    * Override this method
    */
   public Component getTableCellRendererComponent(JTable table,
                                                  Object value,
                                                  boolean isSelected,
                                                  boolean hasFocus,
                                                  int row,
                                                  int column)
   {
      super.getTableCellRendererComponent(table,value,isSelected,hasFocus,row,column);

      if ( (value == null) && (column != 0) )
         return this;

      if (value instanceof String)
      {
         if (ServerStatus.ONLINE.equals((String) value))
         {
            setForeground(isSelected ? darkGreen   : Color.white);
            setBackground(isSelected ? Color.white : darkGreen);
         }
         else
         {
            setForeground(isSelected ? Color.red   : Color.white);
            setBackground(isSelected ? Color.white : Color.red);
         }
      }
      else
      {
         setForeground(Color.black);
         setBackground(Color.white);
      }

      return this;
   }
}
